package com.keypalette.theme.activity

import android.annotation.SuppressLint
import android.content.Intent
import android.graphics.drawable.Drawable
import android.os.Bundle
import android.util.Log
import android.widget.FrameLayout
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.isVisible
import androidx.lifecycle.lifecycleScope
import com.ad.tradpluslibrary.TPAdManager
import com.bumptech.glide.Glide
import com.bumptech.glide.integration.webp.decoder.WebpDrawable
import com.bumptech.glide.load.DataSource
import com.bumptech.glide.load.engine.GlideException
import com.bumptech.glide.request.RequestListener
import com.bumptech.glide.request.target.Target
import com.keypalette.theme.KeyApp
import com.keypalette.theme.R
import com.keypalette.theme.dataabout.database.LikeFunction
import com.keypalette.theme.dataabout.resource.Data
import com.keypalette.theme.other.Helper
import com.keypalette.theme.other.SpSkins
import com.keypalette.theme.other.ZipFile
import com.keypalette.theme.other.listener.ListenerDownload
import kotlinx.coroutines.launch
import java.io.File


class PageApply : AppCompatActivity() {
    companion object {
        @JvmField
        val SOURCE_KEY = "data_key"
    }
    private lateinit var displayUrl: String
    private lateinit var gifUrl: String
    private lateinit var zipUrl: String
    private lateinit var name: String
    private lateinit var applyBtn: LinearLayout
    private lateinit var imgData: ImageView
    private lateinit var imgBack: ImageView
    private lateinit var textName: TextView

//    private lateinit var recommendedRecycler: RecyclerView
    private lateinit var loadingLayout: FrameLayout

    private lateinit var unzipPath: String

    private lateinit var tvDownload: TextView
    private lateinit var imDownload: ImageView

    private lateinit var thumb: String

    private lateinit var imgLike: ImageView

    private lateinit var data: Data

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.page_apply)
        Helper.initFullScreen(this,true)
        
        findViewId()
        getExtraData()
        displayData()
        setApply()
        onClick()
        TPAdManager.showTPAD(this) { null }
    }


    private fun getExtraData() {
        data = intent.getSerializableExtra(SOURCE_KEY) as Data

        displayUrl = data.imgPath
        zipUrl = data.zipPath
        name = data.titleName
        gifUrl = data.imgGif
        data.thumbGif?.let {
            thumb = it
        }
        data.thumbUrl?.let {
            thumb = it
        }
        val serviceZipName = ZipFile.getServiceZipName(zipUrl)
        Log.d(KeyApp.Companion.TAG, "--------serviceZipName=$serviceZipName")
        unzipPath = ZipFile.getUnzipPath(serviceZipName)


        lifecycleScope.launch {
            LikeFunction.getIsLike(name) {
                imgLike.isSelected = it
            }
        }

        if (File(unzipPath).exists()) {
            imDownload.isVisible = false
            tvDownload.text = getString(R.string.apply)
        } else {
            imDownload.isVisible = true
            tvDownload.text = getString(R.string.download_apply)
        }

    }

    private fun findViewId() {
        applyBtn = findViewById(R.id.layoutDownloadApply)
        imgData = findViewById(R.id.image_data)
        imgBack = findViewById(R.id.back)
        textName = findViewById(R.id.textview_data_name)
//        recommendedRecycler = findViewById(R.id.recommended_recycler)
//        viewAllLayout = findViewById(R.id.layout_view_all)

        imgLike = findViewById(R.id.im_like)
        loadingLayout = findViewById(R.id.loading)
        imDownload = findViewById(R.id.im_download)
        tvDownload = findViewById(R.id.tv_download)
    }

    private fun displayData() {
        textName.text = name
        if (gifUrl.isNotEmpty()) {
            loadImgGif()
        } else {
            Glide.with(this)
                .load(displayUrl)
                .placeholder(R.drawable.default_placeholder)
                .thumbnail(Glide.with(this).load(thumb))
                .into(imgData)
        }
    }


    private fun onClick() {
        imgBack.setOnClickListener {
            finish()
        }

        imgLike.setOnClickListener {
            imgLike.isSelected = !imgLike.isSelected

            lifecycleScope.launch {
                if (imgLike.isSelected) {
                    LikeFunction.addLike(data)
                } else {
                    LikeFunction.removeLike(data)
                }
            }

        }
        val forYouList = KeyApp.Companion.list.filter {
            it.parentName == getString(R.string.recommend_name)

        }



    }

    @SuppressLint("CheckResult")
    private fun loadImgGif() {
        Glide.with(this)
            .load(gifUrl)
            .placeholder(R.drawable.default_placeholder)
            .thumbnail(Glide.with(this).load(thumb))
            .addListener(object : RequestListener<Drawable> {
                override fun onLoadFailed(
                    e: GlideException?,
                    model: Any?,
                    target: Target<Drawable>,
                    isFirstResource: Boolean
                ): Boolean {

                    return false
                }

                override fun onResourceReady(
                    resource: Drawable,
                    model: Any,
                    target: Target<Drawable>?,
                    dataSource: DataSource,
                    isFirstResource: Boolean
                ): Boolean {
                    if (resource is WebpDrawable) {
                        resource.loopCount = WebpDrawable.LOOP_FOREVER
                    }

                    return false
                }

            }).into(imgData)
    }

    private fun setApply() {
        applyBtn.setOnClickListener {


            TPAdManager.showTPAD(this@PageApply){
                startDown()
            }

        }
    }



    private fun startDown() {
        loadingLayout.isVisible = true
        applyBtn.isEnabled = false

        val file = File(unzipPath)
        if (file.exists()) {
            val findFirstDirectory = ZipFile.findFirstDirectory(file)

            apply("${findFirstDirectory}/")
            applyBtn.isEnabled = true
            loadingLayout.isVisible = false
        } else {
            ZipFile.startDownloadZip(zipUrl, object :
                ListenerDownload {
                override fun OnApplySkinListener(fileList: List<File?>?) {
                    runOnUiThread {
                        applyBtn.isEnabled = true
                        loadingLayout.isVisible = false
                    }
                    if (fileList.isNullOrEmpty()) {
                        runOnUiThread {
                            Toast.makeText(
                                this@PageApply,
                                getString(R.string.download_fail),
                                Toast.LENGTH_SHORT
                            ).show()
                        }
                    } else {
//                        lifecycleScope.launch {
//                            DbManager.addDownload(data)
//                        }
                        if (file.exists()) {
                            val findFirstDirectory = ZipFile.findFirstDirectory(file)
                            Log.d(
                                KeyApp.Companion.TAG,
                                "----apply------------it=$findFirstDirectory"
                            )
                            runOnUiThread {
                                apply("${findFirstDirectory}/")

                            }
                        }
                    }


                }

            })
        }

    }

    private fun apply(path: String) {
        var skinParentPath = path
        if (path.contains("res")) {
            skinParentPath = path.substringBeforeLast("res")
        }


        SpSkins.updateSkinPath(skinParentPath)
        Toast.makeText(
            this@PageApply,
            getString(R.string.theme_application_successful),
            Toast.LENGTH_SHORT
        ).show()
        startActivity(Intent(this, PageSuccess::class.java).apply {
            putExtra(PageSuccess.key_name, name)
        })
        finish()
    }




}